﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

using Syncfusion.DocIO;
using Syncfusion.DocIO.DLS;
using System.IO;

namespace MailMergeDocIO_Application.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult PerformMailmerge()
        {
            //Open template Word Document.
            WordDocument wordDocument = new WordDocument(Server.MapPath("..//App_Data//input_template.docx"), FormatType.Docx);
            //Get values for LineItem table group.
            List<LineItem> lineItem = GetLineItem();
            //Create MailMergeDataTable with values of LineItem table group.
            MailMergeDataTable mailMergeDataTable = new MailMergeDataTable("LineItem", lineItem);
            //Perform Mail merge.
            wordDocument.MailMerge.ExecuteGroup(mailMergeDataTable);
            #region Document Save
            MemoryStream memoryStream = new MemoryStream();
            wordDocument.Save(memoryStream, FormatType.Docx);
            memoryStream.Position = 0;
            //Setting HTTP content Type 
            string strContentType = "application/ms-word";
            //Display type
            string strDispType = "attachment";
            //Adding information to the header
            Response.AddHeader("Content-Type", strContentType);
            Response.AddHeader("Content-Disposition", string.Format("{0};filename={1};", strDispType, "Sample.docx"));
            memoryStream.CopyTo(Response.OutputStream);
            memoryStream.Dispose();
            Response.End();
            #endregion Document Save

            return View();
        }
        /// <summary>
        /// Gets LineItem for DataTable.
        /// </summary>
        /// <returns></returns>
        public List<LineItem> GetLineItem()
        {
            List<LineItem> lineItem = new List<LineItem>();
            lineItem.Add(new LineItem("A", "1", "a", "I", "i"));
            lineItem.Add(new LineItem("B", "2", "b", "II", "ii"));
            lineItem.Add(new LineItem("C", "3", "c", "III", "iii"));
            lineItem.Add(new LineItem("D", "4", "c", "IV", "iv"));
            return lineItem;
        }
        public ActionResult Index()
        {
            return View();
        }
    }
    #region LineItem for datatable
    /// <summary>
    /// Class for LineItem TableGroup
    /// </summary>
    public class LineItem
    {
        public string Description { get; set; }
        public string Quantity { get; set; }
        public string UnitAmount { get; set; }
        public string TaxPercentageOrName { get; set; }
        public string LineAmount { get; set; }
        public LineItem(string description, string quantity, string unitAmount, string taxPercentageOrName, string lineAmount)
        {
            Description = description;
            Quantity = quantity;
            UnitAmount = unitAmount;
            TaxPercentageOrName = taxPercentageOrName;
            LineAmount = lineAmount;
        }
    }
    #endregion LineItem for datatable
}